program cddblist; (* stk  05/02, 10/07 *)
uses sysutils;
var param,filename:string;
    titlelen,p:integer;
    
procedure cddbdir(path:string);
 var entry:tsearchrec;
     status:longint;

 procedure prtinfo(filename:string);
  var datein:text;
      discid,dtitle,dyear,line:string;
  begin
   discid:=''; dtitle:=''; dyear:='';
   assign(datein,filename); reset(datein);
   while not(eof(datein)) do begin
    readln(datein,line);
    if copy(line,1,7)='DISCID=' then discid:=copy(line,8,length(line)-7);
    if copy(line,1,7)='DTITLE=' then dtitle:=copy(line,8,length(line)-7);
    if copy(line,1,6)='DYEAR='  then dyear:=copy(line,7,length(line)-6);
   end;
   close(datein);
   if dtitle<>'' then begin
    if pos('t',param)<>0 then begin 
     if length(dtitle)<titlelen then
      write(dtitle,'':titlelen-length(dtitle))
     else
      write(copy(dtitle,1,titlelen));
     write('  ');
    end;
    if pos('y',param)<>0 then write(copy(dyear+'      ',1,6)); 
    if pos('i',param)<>0 then write(discid,'  ');
    if pos('n',param)<>0 then write(filename,'  ');
    writeln;
   end;
  end;

 begin
  if path[length(path)]<>'/' then path:=path+'/';
  status:=findfirst(path+'*',fadirectory,entry);
  while status=0 do begin
   if (entry.attr and fadirectory=fadirectory) and (entry.name[1]<>'.') then begin
    cddbdir(path+entry.name);
   end else begin
    if entry.name[1]<>'.' then prtinfo(path+entry.name);
   end;
   status:=findnext(entry);
  end;
  findclose(entry);
 end;

begin
 if paramcount<=3 then begin
  if paramcount=0 then
   filename:=getenvironmentvariable('HOME')+'/.cddb/'
  else
   filename:=paramstr(1);
  if paramcount>=2 then param:=paramstr(2) else param:='ty';
  titlelen:=0; if paramcount=3 then val(paramstr(3),titlelen,p);
  if titlelen=0 then titlelen:=72;
  cddbdir(filename);
 end else
  writeln(paramstr(0),' [directory] [format: tyin (title, year, discid, filename)] [titlelength]');
end.
